	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE terminal.inc		; terminal function definitions	
	EXPORT	main	

;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	Terminal_setup		; setup TeraTerm communication

	OORW	(0xF<<20), 0, CPACR	; enable FPU
	dsb

	vmov.f	S5, #2			; number to take sart of
	vldr.f	S0, =0.000001		; accuracy
	vsub.f	S1, S1, S1		; lower bound	
	vmov.f	S2, S5			; upper bound
	vmov.f	S8, S2
	
L1	vadd.f	S3, S1, S2		; S3 = midpoint
	vdiv.f	S3, S3, S8
	vmul.f	S4, S3, S3		; S4 = midpoint^2
	vcmp.f	S4, S5
	vmrs	APSR_nzcv, FPSCR	; copy flags to CPU status
	vmovlt.f S1, S3
	vmovge.f S2, S3
	
	vsub.f	S4, S2, S1		; S4 - u.b. - l.b.
	vcmp.f	S4, S0
	vmrs	APSR_nzcv, FPSCR	; copy flags to CPU status
	bgt	L1

	vadd.f	S0, S1, S2		; report (l.b+u.b)/2
	vmov.f	S1, #2
	vdiv.f	S0, S1			; S0 = sqrt(S5)
		
loop	b	loop				
	ENDP

	ALIGN
	END